diff --git a/corefreqk.c b/corefreqk.c
index f88bc6e0..2fa363bb 100644
--- a/corefreqk.c
+++ b/corefreqk.c
@@ -1690,22 +1690,22 @@ void OverrideUnlockCapability(PROCESSOR_SPECIFIC *pSpecific)
 
 PROCESSOR_SPECIFIC *LookupProcessor(void)
 {
-	char *lookIn = NULL;
-
 	PROCESSOR_SPECIFIC *pSpecific;
     for (pSpecific = Arch[Proc->ArchID].Specific;
-	(pSpecific != NULL) && (pSpecific->Brand != NULL) && (lookIn == NULL);
-		pSpecific++)
+		(pSpecific != NULL) && (pSpecific->Brand != NULL);
+			pSpecific++)
     {
 	char **brands, *brand;
 	for (brands = pSpecific->Brand, brand = *brands;
-		(brand != NULL) && (lookIn == NULL);
+		brand != NULL;
 			brands++, brand = *brands)
 	{
-		lookIn = strstr(Proc->Features.Info.Brand, brand);
+		if (strstr(Proc->Features.Info.Brand, brand)) {
+			return (pSpecific);
+		}
 	}
     }
-	return (pSpecific);
+	return (NULL);
 }
 
 int Intel_MaxBusRatio(PLATFORM_ID *PfID)
